#ifndef MAIN_WIDGET_H
#define MAIN_WIDGET_H

//    This file is part of JustMotion.

//    JustMotion is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustMotion is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"
#include "recents.h"
#include "playlist_widget.h"

class MainGui : public QMainWindow
{
    Q_OBJECT

private:

    shared_t *shared;

    void closeEvent(QCloseEvent *event);

public:

    explicit MainGui(shared_t *share, QWidget *parent = nullptr);
};

class MainWidget : public QWidget
{
    Q_OBJECT

private:

    shared_t    *shared;
    ssh_opt     *sshOpts;
    MainGui     *mainGui;
    QVBoxLayout *homeLayout;
    QComboBox   *hostAddr;
    QPushButton *sshOptBtn;
    QPushButton *connectBtn;
    QPushButton *closeBtn;
    QLineEdit   *playerCmd;
    QGroupBox   *liveWid;
    QGroupBox   *footageWid;
    QWidget     *spacer;
    Recents     *recents;

    void genConnectWidget();
    void genSettingsWidget();
    void genSpacer();
    void closeEvent(QCloseEvent *event);

private slots:

    void open();
    void close();
    void openSshOptsDialog();
    void resetPlayerDefault();
    void updatePlayerCmd(const QString &line);

public:

    explicit MainWidget(shared_t *share, MainGui *parent);
};

#endif // MAIN_WIDGET_H
