#ifndef PLAYLIST_WIDGET_H
#define PLAYLIST_WIDGET_H

//    This file is part of JustMotion.

//    JustMotion is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustMotion is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"

enum play_item_t
{
    CAM_LIVE,
    CAM_FOOTAGE
};

class PlaylistItem : public QLabel
{
    Q_OBJECT

private:

    QLabel   *image;
    QLabel   *title;
    QDialog  *popMsg;
    QLabel   *popMsgText;
    QTimer   *confChecker;
    shared_t *appShare;
    QProcess *proc;
    QString   conf;
    QString   basePath;

    void mouseReleaseEvent(QMouseEvent *event);
    void leaveEvent(QEvent *event);
    void enterEvent(QEnterEvent *event);
    void genImgAndText();
    void loadImgFromFile(QString path);
    void dispText();

private slots:

    void checkConfExists();
    void playerExited();

public:

    explicit PlaylistItem(shared_t *appConf, const QString &path, const QString &confPath, QWidget *parent);

signals:

    void rmItem(const QString &confPath, const QWidget *item);
};

class PlaylistWidget : public QScrollArea
{
    Q_OBJECT

private:

    shared_t       *shared;
    QGridLayout    *listLayout;
    QStringList     fileList;
    play_item_t     itemType;
    QList<QWidget*> widList;
    QList<QWidget*> spcList;

    void reGrid();
    void showEvent(QShowEvent *event);
    void resizeEvent(QResizeEvent *event);

private slots:

    void rmItem(const QString &confPath, const QWidget *item);
    void scan();

public:

    explicit PlaylistWidget(shared_t *share, play_item_t type, QWidget *parent);
};

#endif // PLAYLIST_WIDGET_H
