#ifndef RECENTS_H
#define RECENTS_H

//    This file is part of JustMotion.

//    JustMotion is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    JustMotion is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

#include "common.h"

class RecentItem : public QObject
{
    Q_OBJECT

private:

    QString  confPath;
    ssh_opt *sshOpts;

private slots:

    void itemSelected(const QString &name);

public:

    explicit RecentItem(const QString &path, QComboBox *box, ssh_opt *opts, QObject *parent = nullptr);
};

class Recents : public QObject
{
    Q_OBJECT

private:

    QFileSystemWatcher mon;
    shared_t          *share;
    ssh_opt           *sshOpts;
    QComboBox         *comboBox;

private slots:

    void scan();

public:

    explicit Recents(shared_t *shareedRes, QComboBox *box, ssh_opt *opts, QObject *parent = nullptr);

signals:

    void clear();
};

#endif // RECENTS_H
